Index: /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/LIM_SRC_3/ice.F90
===================================================================
--- /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/LIM_SRC_3/ice.F90	(revision 1858)
+++ /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/LIM_SRC_3/ice.F90	(revision 1859)
@@ -1,39 +1,22 @@
 MODULE ice
+   !!======================================================================
+   !!                        ***  MODULE ice  ***
+   !! LIM-3 sea ice :   variables defined in memory
+   !!=====================================================================
+   !! History :  3.0  ! 2008-03  (M. Vancoppenolle)  LIM3 original code
+   !!            3.1  ! 2010-05  (Y. Aksenov, M. Vancoppenolle, G. Madec) add heat content exchanges
+   !!----------------------------------------------------------------------
 #if defined key_lim3
    !!----------------------------------------------------------------------
    !!   'key_lim3' :                                   LIM3 sea-ice model
    !!----------------------------------------------------------------------
-   !! History :
-   !!   2.0  !  03-08  (C. Ethe)  F90: Free form and module
-   !!   3.0  !  08-03  (M. Vancoppenolle) : LIM3 !
-   !!----------------------------------------------------------------------
-   !!  LIM 3.0, UCL-LOCEAN-IPSL (2005)
-   !! $Id$
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt
-   !!----------------------------------------------------------------------
-   !! * Modules used
    USE par_ice          ! LIM sea-ice parameters
 
    IMPLICIT NONE
    PRIVATE
-   !!
-   !!======================================================================
-   !!                        ***  MODULE ice  ***
-   !!
-   !!                           **************
-   !!                           * L I M  3.0 *
-   !!                           **************
-   !!
-   !!                         ''in ice we trust''
-   !!
-   !!                   This module contains the sea ice 
-   !!                 diagnostics variables of ice defined 
-   !!                             in memory
-   !!
-   !!======================================================================
-   !!
+
+   !!----------------------------------------------------------------------
    !! LIM3 by the use of sweat, agile fingers and sometimes brain juice, 
    !!  was developed in Louvain-la-Neuve by : 
-   !!
    !!    * Martin Vancoppenolle (UCL-ASTR, Belgium)
    !!    * Sylvain Bouillon (UCL-ASTR, Belgium)
@@ -41,28 +24,21 @@
    !! 
    !! Based on extremely valuable earlier work by
-   !!
    !!    * Thierry Fichefet
    !!    * Hugues Goosse
    !!
    !! The following persons also contributed to the code in various ways
-   !!
    !!    * Gurvan Madec, Claude Talandier, Christian Ethe 
    !!      and Rachid Benshila (LOCEAN-IPSL, France)
    !!    * Xavier Fettweis (UCL-ASTR), Ralph Timmermann (AWI, Germany)
-   !!    * Bill Lipscomb (LANL), Cecilia Bitz (UWa) 
-   !!      and Elisabeth Hunke (LANL), USA.
+   !!    * Bill Lipscomb (LANL), Cecilia Bitz (UWa) and Elisabeth Hunke (LANL), USA.
    !! 
    !! (c) UCL-ASTR, 2005-2008
    !!
-   !! For more info, the interested user is kindly invited to consult the
-   !! following references
+   !! For more info, the interested user is kindly invited to consult the following references
    !!    For model description and validation :
    !!    * Vancoppenolle et al., Ocean Modelling, 2008a.
    !!    * Vancoppenolle et al., Ocean Modelling, 2008b.
-   !!
    !!    For a specific description of EVP :
    !!    * Bouillon et al., in prep for 2008.
-   !!
-   !!    Or the reference manual, that should be available by 2009
    !!
    !!======================================================================
@@ -183,6 +159,5 @@
    !!=====================================================================
 
-   LOGICAL, PUBLIC ::    &
-      con_i = .false.           ! switch for conservation test
+   LOGICAL, PUBLIC ::   con_i = .false.   ! switch for conservation test
 
    !!--------------------------------------------------------------------------
@@ -310,6 +285,8 @@
       phicif ,   &  !: Old ice thickness
       fbif   ,   &  !: Heat flux at the ice base
-      rdmsnif,   &  !: Variation of snow mass
-      rdmicif,   &  !: Variation of ice mass
+      rdm_snw,   &  !: Variation of snow mass over 1 time step           [Kg/m2]
+      rdq_snw,   &  !: heat content associated to rdm_snw                [J/m2]
+      rdm_ice,   &  !: Variation of ice  mass over 1 time step           [Kg/m2]
+      rdq_ice,   &  !: heat content associated to rdm_ice                [J/m2]
       qldif  ,   &  !: heat balance of the lead (or of the open ocean)
       qcmif  ,   &  !: Energy needed to bring the ocean surface layer until its freezing 
@@ -506,4 +483,8 @@
 #endif
 
+   !!----------------------------------------------------------------------
+   !! NEMO/LIM 3.0, UCL-LOCEAN-IPSL (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!======================================================================
 END MODULE ice
Index: /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/LIM_SRC_3/thd_ice.F90
===================================================================
--- /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/LIM_SRC_3/thd_ice.F90	(revision 1858)
+++ /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/LIM_SRC_3/thd_ice.F90	(revision 1859)
@@ -2,14 +2,9 @@
    !!======================================================================
    !!                       ***  MODULE thd_ice  ***
-   !! LIM sea-ice :   Ice thermodynamics in 1D
+   !! LIM-3 sea-ice :   Ice thermodynamics in 1D
    !!=====================================================================
-   !! History :
-   !!   2.0  !  02-11  (C. Ethe)  F90: Free form and module
+   !! History :  3.0  ! 2008-03  (M. Vancoppenolle)  LIM3 original code
+   !!            3.1  ! 2010-05  (Y. Aksenov, M. Vancoppenolle, G. Madec) add heat content exchanges
    !!----------------------------------------------------------------------
-   !!   LIM 3.0, UCL-LOCEAN-IPSL (2008)
-   !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
-   !! * Modules used
    USE par_ice
 
@@ -73,6 +68,8 @@
       at_i_b      ,     &  !:    "                  "      frld
       fbif_1d     ,     &  !:    "                  "      fbif
-      rdmicif_1d  ,     &  !:    "                  "      rdmicif
-      rdmsnif_1d  ,     &  !:    "                  "      rdmsnif
+      rdm_ice_1d  ,     &  !:    "                  "      rdm_ice
+      rdq_ice_1d  ,     &  !:    "                  "      rdm_ice
+      rdm_snw_1d  ,     &  !:    "                  "      rdm_snw
+      rdq_snw_1d  ,     &  !:    "                  "      rdm_snw
       qlbbq_1d    ,     &  !:    "                  "      qlbsbq
       dmgwi_1d    ,     &  !:    "                  "      dmgwi
@@ -149,15 +146,14 @@
       ftotal_fin               !: final total heat flux
 
-   REAL(wp), PUBLIC, DIMENSION(jpij,0:nlay_s) ::   &  !:
-      fc_s
-   REAL(wp), PUBLIC, DIMENSION(jpij,0:jkmax)  ::   &  !:
-      fc_i
-   REAL(wp), PUBLIC, DIMENSION(jpij,nlay_s) ::   &  !:
-      de_s_lay
-   REAL(wp), PUBLIC, DIMENSION(jpij,jkmax)  ::   &  !:
-      de_i_lay
-   INTEGER , PUBLIC ::                           &
-      jiindex_1d   ! 1D index of debugging point
+   REAL(wp), PUBLIC, DIMENSION(jpij,0:nlay_s) ::   fc_s
+   REAL(wp), PUBLIC, DIMENSION(jpij,0:jkmax)  ::   fc_i
+   REAL(wp), PUBLIC, DIMENSION(jpij,nlay_s)   ::   de_s_lay
+   REAL(wp), PUBLIC, DIMENSION(jpij,jkmax)    ::   de_i_lay
+   INTEGER , PUBLIC                           ::   jiindex_1d   ! 1D index of debugging point
 
+   !!----------------------------------------------------------------------
+   !! NEMO/LIM 3.0, UCL-LOCEAN-IPSL (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!======================================================================
 END MODULE thd_ice
Index: /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/OPA_SRC/SBC/sbcana.F90
===================================================================
--- /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/OPA_SRC/SBC/sbcana.F90	(revision 1858)
+++ /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/OPA_SRC/SBC/sbcana.F90	(revision 1859)
@@ -6,4 +6,5 @@
    !! History :  3.0   ! 2006-06  (G. Madec)  Original code
    !!            3.2   ! 2009-07  (G. Madec)  Style only
+   !!            3.3  !  2010-07  (Y. Aksenov G. Madec) salt flux + heat associated with emp
    !!----------------------------------------------------------------------
 
@@ -39,5 +40,5 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
+   !! NEMO/OPA 3.3 , LOCEAN-IPSL (2010) 
    !! $Id$
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
@@ -60,5 +61,5 @@
       !!
       !! ** Action  : - set the ocean surface boundary condition, i.e.  
-      !!                   utau, vtau, taum, wndm, qns, qsr, emp, emps
+      !!                   utau, vtau, taum, wndm, qns, qsr, emp
       !!----------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt       ! ocean time step
@@ -88,8 +89,7 @@
          !
          nn_tau000 = MAX( nn_tau000, 1 )   ! must be >= 1
-         qns   (:,:) = rn_qns0
-         qsr   (:,:) = rn_qsr0
-         emp   (:,:) = rn_emp0
-         emps  (:,:) = rn_emp0
+         emp(:,:) = rn_emp0
+         qns(:,:) = rn_qns0 - emp(:,:) * sst_m(:,:) * rcp      ! including heat content associated with mass flux at SST
+         qsr(:,:) = rn_qsr0
          !
       ENDIF
@@ -123,5 +123,5 @@
       !!
       !! ** Action  : - set the ocean surface boundary condition, i.e.   
-      !!                   utau, vtau, taum, wndm, qns, qsr, emp, emps
+      !!                   utau, vtau, taum, wndm, qns, qsr, emp
       !!
       !! Reference : Hazeleger, W., and S. Drijfhout, JPO, 30, 677-695, 2000.
@@ -204,5 +204,4 @@
          END DO
       END DO
-      emps(:,:) = emp(:,:)
 
       ! Compute the emp flux such as its integration on the whole domain at each time is zero
@@ -226,7 +225,8 @@
       ENDIF
 
-      !salinity terms
-      emp (:,:) = emp(:,:) - zsumemp * tmask(:,:,1)
-      emps(:,:) = emp(:,:)
+      
+      ! freshwater (mass flux) and update of qns with heat content of emp
+      emp (:,:) = emp(:,:) - zsumemp * tmask(:,:,1)        ! freshwater flux (=0 in domain average)
+      qns (:,:) = qns(:,:) - emp(:,:) * sst_m(:,:) * rcp   ! evap and precip are at SST
 
 
Index: /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/OPA_SRC/SBC/sbcblk_clio.F90
===================================================================
--- /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/OPA_SRC/SBC/sbcblk_clio.F90	(revision 1858)
+++ /branches/DEV_r1837_mass_heat_salt_fluxes/NEMO/OPA_SRC/SBC/sbcblk_clio.F90	(revision 1859)
@@ -9,13 +9,14 @@
    !!            3.0  !  2008-03 (C. Talandier, G. Madec) surface module + LIM3
    !!            3.2  !  2009-04 (B. Lemaire) Introduce iom_put
+   !!            3.3  !  2010-05 (Y. Aksenov G. Madec) salt flux + heat associated with emp
    !!----------------------------------------------------------------------
 
    !!----------------------------------------------------------------------
-   !!   sbc_blk_clio   : CLIO bulk formulation: read and update required input fields
-   !!   blk_clio_oce   : ocean CLIO bulk formulea: compute momentum, heat and freswater fluxes for the ocean
-   !!   blk_ice_clio   : ice   CLIO bulk formulea: compute momentum, heat and freswater fluxes for the sea-ice
+   !!   sbc_blk_clio     : CLIO bulk formulation: read and update required input fields
+   !!   blk_clio_oce     : ocean CLIO bulk formulea: compute momentum, heat and freswater fluxes for the ocean
+   !!   blk_ice_clio     : ice   CLIO bulk formulea: compute momentum, heat and freswater fluxes for the sea-ice
    !!   blk_clio_qsr_oce : shortwave radiation for ocean computed from the cloud cover
    !!   blk_clio_qsr_ice : shortwave radiation for ice   computed from the cloud cover
-   !!   flx_blk_declin : solar declinaison
+   !!   flx_blk_declin   : solar declinaison
    !!----------------------------------------------------------------------
    USE oce             ! ocean dynamics and tracers
@@ -47,6 +48,6 @@
    INTEGER , PARAMETER ::   jp_vtau = 2           ! index of wind stress (j-component)      (N/m2)    at V-point
    INTEGER , PARAMETER ::   jp_wndm = 3           ! index of 10m wind module                 (m/s)    at T-point
-   INTEGER , PARAMETER ::   jp_humi = 4           ! index of specific humidity               ( - )
-   INTEGER , PARAMETER ::   jp_ccov = 5           ! index of cloud cover                     ( - )
+   INTEGER , PARAMETER ::   jp_humi = 4           ! index of specific humidity               ( % )
+   INTEGER , PARAMETER ::   jp_ccov = 5           ! index of cloud cover                     ( % )
    INTEGER , PARAMETER ::   jp_tair = 6           ! index of 10m air temperature             (Kelvin)
    INTEGER , PARAMETER ::   jp_prec = 7           ! index of total precipitation (rain+snow) (Kg/m2/s)
@@ -81,5 +82,5 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
+   !! NEMO/OPA 3.3 , LOCEAN-IPSL (2010) 
    !! $Id$ 
    !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
@@ -98,14 +99,13 @@
       !!      the i-component of the stress                (N/m2)
       !!      the j-component of the stress                (N/m2)
-      !!      the 10m wind pseed module                    (m/s)
+      !!      the 10m wind speed module                    (m/s)
       !!      the 10m air temperature                      (Kelvin)
-      !!      the 10m specific humidity                    (-)
-      !!      the cloud cover                              (-)
+      !!      the 10m specific humidity                    (%)
+      !!      the cloud cover                              (%)
       !!      the total precipitation (rain+snow)          (Kg/m2/s)
       !!              (2) CALL blk_oce_clio
       !!
       !!      C A U T I O N : never mask the surface stress fields
-      !!                      the stress is assumed to be in the mesh referential
-      !!                      i.e. the (i,j) referential
+      !!                      the stress is assumed to be in the (i,j) mesh referential
       !!
       !! ** Action  :   defined at each time-step at the air-sea interface
@@ -113,6 +113,8 @@
       !!              - taum        wind stress module at T-point
       !!              - wndm        10m wind module at T-point
-      !!              - qns, qsr    non-slor and solar heat flux
-      !!              - emp, emps   evaporation minus precipitation
+      !!              - qns         non-solar heat flux including latent heat of solid 
+      !!                            precip. melting and emp heat content
+      !!              - qsr         solar heat flux
+      !!              - emp         upward mass flux (evap. - precip)
       !!----------------------------------------------------------------------
       INTEGER, INTENT( in  ) ::   kt   ! ocean time step
@@ -175,10 +177,12 @@
       !                                         ! ====================== !
       !
-      CALL fld_read( kt, nn_fsbc, sf )                ! input fields provided at the current time-step
+      CALL fld_read( kt, nn_fsbc, sf )                                        ! input fields  at the current time-step
       !
 #if defined key_lim3      
-      tatm_ice(:,:) = sf(jp_tair)%fnow(:,:)     !RB ugly patch
+      tatm_ice(:,:) = sf(jp_tair)%fnow(:,:)                                   ! Tair needed in LIM-3 (!RB ugly patch)
 #endif
-      !
+      IF( MOD( kt - 1, nn_fsbc ) == 0 )   CALL blk_oce_clio( sf, sst_m )      ! surface ocean fluxes using CLIO bulk formulea
+      ENDIF                                               ! 
+      
       IF(lwp .AND. nitend-nit000 <= 100 ) THEN
          IF( MOD( kt-1, nn_fsbc ) == 0 ) THEN
@@ -210,8 +214,4 @@
          ENDIF
       ENDIF
-
-      IF( MOD( kt - 1, nn_fsbc ) == 0 ) THEN
-          CALL blk_oce_clio( sf, sst_m )                  ! compute the surface ocean fluxes using CLIO bulk formulea
-      ENDIF                                               ! 
       !
    END SUBROUTINE sbc_blk_clio
@@ -239,6 +239,8 @@
       !!               - taum        wind stress module at T-point
       !!               - wndm        10m wind module at T-point
-      !!               - qns, qsr    non-slor and solar heat flux
-      !!               - emp, emps   evaporation minus precipitation
+      !!               - qns         non-solar heat flux including latent heat of solid 
+      !!                             precip. melting and emp heat content
+      !!               - qsr         solar heat flux
+      !!               - emp         suface mass flux (evap.-precip.)
       !!  ** Nota    :   sf has to be a dummy argument for AGRIF on NEC
       !!----------------------------------------------------------------------
@@ -257,5 +259,5 @@
       REAL(wp) ::   zsst, ztatm, zcco1, zpatm, zcmax, zrmax     !    -         -
       REAL(wp) ::   zrhoa, zev, zes, zeso, zqatm, zevsqr        !    -         -
-      REAL(wp) ::   ztx2, zty2                                  !    -         -
+      REAL(wp) ::   ztx2, zty2, zcevap, zcprec                  !    -         -
       !!
       REAL(wp), DIMENSION(jpi,jpj) ::   zqlw        ! long-wave heat flux over ocean
@@ -270,10 +272,13 @@
       !------------------------------------!
 !CDIR COLLAPSE
-      DO jj = 1 , jpj
-         DO ji = 1, jpi
-            utau(ji,jj) = sf(jp_utau)%fnow(ji,jj)
-            vtau(ji,jj) = sf(jp_vtau)%fnow(ji,jj)
-         END DO
-      END DO
+      utau(:,:) = sf(jp_utau)%fnow(:,:)
+!CDIR COLLAPSE
+      vtau(:,:) = sf(jp_vtau)%fnow(:,:)
+
+      !------------------------------------!
+      !   store the wind speed  (wndm )    !
+      !------------------------------------!
+!CDIR COLLAPSE
+      wndm(:,:) = sf(jp_wndm)%fnow(:,:)
 
       !------------------------------------!
@@ -291,18 +296,7 @@
       CALL lbc_lnk( taum, 'T', 1. )
 
-      !------------------------------------!
-      !   store the wind speed  (wndm )    !
-      !------------------------------------!
-!CDIR COLLAPSE
-      DO jj = 1 , jpj
-         DO ji = 1, jpi
-            wndm(ji,jj) = sf(jp_wndm)%fnow(ji,jj)
-         END DO
-      END DO
-
       !------------------------------------------------!
       !   Shortwave radiation for ocean and snow/ice   !
       !------------------------------------------------!
-      
       CALL blk_clio_qsr_oce( qsr )
 
@@ -401,16 +395,17 @@
       !     III    Total FLUXES                                                       !
       ! ----------------------------------------------------------------------------- !
-
-!CDIR COLLAPSE
-!CDIR NOVERRCHK
-      DO jj = 1, jpj
-!CDIR NOVERRCHK
-         DO ji = 1, jpi
-            qns (ji,jj) = zqlw(ji,jj) - zqsb(ji,jj) - zqla(ji,jj)      ! Downward Non Solar flux
-            emp (ji,jj) = zqla(ji,jj) / cevap - sf(jp_prec)%fnow(ji,jj) / rday * tmask(ji,jj,1)
-         END DO
-      END DO
-      emps(:,:) = emp(:,:)
-      !
+      zcevap = rcp /  cevap    ! convert zqla ==> evap (Kg/m2/s) ==> m/s ==> W/m2
+      zcprec = rcp /  rday     ! convert prec ( mm/day ==> m/s)  ==> W/m2
+
+!CDIR COLLAPSE
+      emp(:,:) = zqla(:,:) / cevap                                        &   ! freshwater flux
+         &     - sf(jp_prec)%fnow(:,:) / rday * tmask(:,:,1)
+      !
+!CDIR COLLAPSE
+      qns(:,:) = zqlw(:,:) - zqsb(:,:) - zqla(:,:)                        &   ! Downward Non Solar flux
+         &     - zqla(:,:)             * pst(:,:)              * zcevap   &   ! remove evap.   heat content at SST in Celcius
+         &     + sf(jp_prec)%fnow(:,:) * sf(jp_tair)%fnow(:,:) * zcprec       ! add    precip. heat content at Tair in Celcius
+      ! NB: if sea-ice model, the snow precip are computed and the associated heat is added to qns (see blk_ice_clio)
+
       CALL iom_put( "qlw_oce",   zqlw )   ! output downward longwave  heat over the ocean
       CALL iom_put( "qsb_oce", - zqsb )   ! output downward sensible  heat over the ocean
@@ -425,5 +420,5 @@
             &         tab2d_2=vtau , clinfo2=' vtau : ', mask2=vmask )
       ENDIF
-
+      !
    END SUBROUTINE blk_oce_clio
 
@@ -447,12 +442,13 @@
       !!
       !!  ** Action  :   call albedo_oce/albedo_ice to compute ocean/ice albedo 
-      !!          computation of snow precipitation
-      !!          computation of solar flux at the ocean and ice surfaces
-      !!          computation of the long-wave radiation for the ocean and sea/ice
-      !!          computation of turbulent heat fluxes over water and ice
-      !!          computation of evaporation over water
-      !!          computation of total heat fluxes sensitivity over ice (dQ/dT)
-      !!          computation of latent heat flux sensitivity over ice (dQla/dT)
-      !!
+      !!               - snow precipitation
+      !!               - solar flux at the ocean and ice surfaces
+      !!               - the long-wave radiation for the ocean and sea/ice
+      !!               - turbulent heat fluxes over water and ice
+      !!               - evaporation over water
+      !!               - total heat fluxes sensitivity over ice (dQ/dT)
+      !!               - latent heat flux sensitivity over ice (dQla/dT)
+      !!               - qns  :  modified the non solar heat flux over the ocean
+      !!                         to take into account solid precip latent heat flux
       !!----------------------------------------------------------------------
       REAL(wp), INTENT(in   ), DIMENSION(:,:,:)   ::   pst      ! ice surface temperature                   [Kelvin]
@@ -633,11 +629,20 @@
       !
       ! ----------------------------------------------------------------------------- !
-      !    Total FLUXES                                                       !
+      !    Total FLUXES                                                               !
       ! ----------------------------------------------------------------------------- !
       !
 !CDIR COLLAPSE
-      p_qns(:,:,:) = z_qlw (:,:,:) - z_qsb (:,:,:) - p_qla (:,:,:)      ! Downward Non Solar flux
+      p_qns(:,:,:) = z_qlw(:,:,:) - z_qsb(:,:,:) - p_qla(:,:,:)         ! Downward Non Solar flux
 !CDIR COLLAPSE
       p_tpr(:,:)   = sf(jp_prec)%fnow(:,:) / rday                       ! total precipitation [kg/m2/s]
+      !
+      ! ----------------------------------------------------------------------------- !
+      !    Correct the OCEAN non solar flux with the existence of solid precipitation !
+      ! ---------------=====--------------------------------------------------------- !
+!CDIR COLLAPSE
+      qns(:,:) = qns(:,:)                                           &   ! update the non-solar heat flux with:
+         &     - p_spr(:,:) * lfus                                                  &   ! remove melting solid precip
+         &     + p_spr(:,:) * MIN( sf(jp_tair)%fnow(:,:), rt0_snow - rt0 ) * cpic   &   ! add solid P at least below melting
+         &     - p_spr(:,:) * sf(jp_tair)%fnow(:,:)                        * rcp        ! remove solid precip. at Tair
       !
 !!gm : not necessary as all input data are lbc_lnk...
@@ -667,6 +672,5 @@
          CALL prt_ctl(tab2d_1=p_taui , clinfo1=' blk_ice_clio: p_taui : ', tab2d_2=p_tauj , clinfo2=' p_tauj : ')
       ENDIF
-
-
+      !
    END SUBROUTINE blk_ice_clio
 
